function Menu() {
	var _this = this;
	var Selector = {};
	var currentModuleId = 1;
	_this.start = function (_obj) {
		Selector = {
			CLASS_NAME: 'main-menu',
			ACTIVITY_CONTAINER: '#screen-container',
			MENU_CONTAINER: '.menu-activity-panel',
			SUB_MENU_CONTAINER: '.sub-menu-activity-panel',
			XML_NODE: APP.globalXmlsObj.globalXML,
			FONT_ICON_CLASS_OBJ: {				
				plus: 'icon-plus',
				minus: 'icon-minus'
			},
			MODE:'',
			CLICK_ARRAY:[],
			ON_INIT: null,
			ON_COMPLETE: null,
			ON_CLICK: null,
			isCompleted: false,
			userData:null
		};
		Selector = $.extend(Selector, _obj);
		initTemplate();
	}
	
	function initTemplate() {
		if(Selector.XML_NODE == null){
			console.warn('XML NOT FOUND...')
			return;
		}
		Selector.isCompleted = false;
		$(Selector.ACTIVITY_CONTAINER).addClass(Selector.CLASS_NAME).addClass(Selector.MODE);
		
		//--get prev value
		Selector.userData = Selector.CLICK_ARRAY;		
		loadMainMenu(true);				
		updateStatus();
	}
	function loadMainMenu(isFirstTime){	
		createMenu();
		$(Selector.ACTIVITY_CONTAINER).find(Selector.SUB_MENU_CONTAINER).hide();
		$(Selector.ACTIVITY_CONTAINER).find(Selector.MENU_CONTAINER).show();
		updateTemplateLayout();
		addTemplateEvent();
	}
	function loadSubMenu(directedLoaded){
		Selector.userData.currView = 'subMenu';
		createSubMenu(Selector.userData.modId);
		$(Selector.ACTIVITY_CONTAINER).find(Selector.MENU_CONTAINER).hide();		
		$(Selector.ACTIVITY_CONTAINER).find(Selector.SUB_MENU_CONTAINER).show();
		updateTemplateLayout();
		addTemplateEvent();
	}

	function createMenu(){		
		createContent();
		updateModButtonStatus();
		updateTopicButtonStatus();
		APP.preloaderObj.hide();
		updateDurationTxt();
		$(Selector.ACTIVITY_CONTAINER).find('.mod-btn-block').find('.plus-minus').removeClass(Selector.FONT_ICON_CLASS_OBJ.minus).addClass(Selector.FONT_ICON_CLASS_OBJ.plus);	
	}
	function createContent(){		
		var str ='';		
		var menuXmlObj = Selector.XML_NODE.menu[0];
		
		for (var i=0; i<menuXmlObj.module.length; i++){
			var curr = menuXmlObj.module[i];
			if(curr.hideOnMenu == 'true'){
				continue;
			}
			var statusClass="not-attempted"
			var modStatus = APP.courseDataObj.getModuleStatus(i);
			if(modStatus == '1'){
				statusClass = "incomplete"
			}
			if(modStatus == '2'){
				statusClass = "complete"
			}
			var mref = 'mod-'+i;
			var mtxt = curr.title[0].Text;
			var ntxt = curr.numText[0].Text;
			var timeTxt = curr.timeText[0].Text;
			var visibleClass = '';
			if(mtxt == null || mtxt == ''){
				visibleClass = 'no-title'
			}
			
			var iconClass = '';
			if(curr.iconClass){				
				iconClass = curr.iconClass;
			}
			
			if(i == 2){
				/* 1 */str += '<div id="'+mref+'" class="mod-btn-block visibility-hidden ani-step '+mref+'  '+statusClass+' '+visibleClass+'">';
					str += '<div class="module-header">';
						str += '<div class="indicator m-indicator indicator-cell ">';								
							str += '<div class="icon-bg"><span class="font-icon status-icon"></span></div>';														
						str += '</div>';
						str+= '<div class ="btn-txt " >';	
							str+= '<div class ="m-txt font-medium" >'+ntxt +' '+ mtxt+'</div>';
						str += '</div>';
						str+= '<div class ="time-txt " >'+timeTxt+'</div>';	
					str += '</div>';
					str += '<div class="sub-mod-panel">';
						str+= '<div class ="instr-div" ></div>';
						str+= createSubTopic(i);
					str += '</div>';
				/* 1 */str += '</div>';
				str+= '<div class ="connector visibility-hidden ani-step" ></div>';
			}else{
				/* 1 */str += '<div id="'+mref+'" class="mod-btn-block visibility-hidden ani-step '+mref+'  '+statusClass+' '+visibleClass+'">';
					str+='<a class="btn module-btn" data-modid="'+i+'" href="javascript:void(0)">';
						str += '<div class="indicator m-indicator indicator-cell ">';								
							str += '<div class="icon-bg"><span class="font-icon status-icon"></span></div>';														
						str += '</div>';
						str+= '<div class ="btn-txt " >';	
							str+= '<div class ="m-txt font-medium" >'+ntxt +' '+ mtxt+'</div>';
						str += '</div>';	
						str+= '<div class ="time-txt " >'+timeTxt+'</div>';				
					str += '</a>';
				/* 1 */str += '</div>';
				str+= '<div class ="connector visibility-hidden ani-step" ></div>';	
				
			}
					
		}
		//--added extra certificate button
		/* if(Selector.MODE === 'static'){
			str += '<div class="btn-panel border-btn certificate-btn-block">';
				str+='<a class="btn certificate-btn " href="javascript:void(0)">';
					str+= '<span class ="btn-txt display-cell v-center center" >'+Selector.XML_NODE.certificateText[0].certificateBtnText[0].Text+'</span>';
				str += '</a>';
			str += '</div>';
		} */
		//module end
		$(Selector.ACTIVITY_CONTAINER).find('.dynamic-panel').html(str);		
		$(Selector.ACTIVITY_CONTAINER).find('.side-content').scrollTop(0);	
		applyTopicBtnEvent();
			
		setTimeout(function(){
			$(Selector.ACTIVITY_CONTAINER).find('.ani-step').removeClass('visibility-hidden');
			APP.animationObj.animate({
				EL: $(Selector.ACTIVITY_CONTAINER).find('.ani-step'),
				TYPE: 'fade-in-top',
				START_VAL:'10px',
				STAGGER: true,
				DURATION: 0.4,
				DElAY: 0.01,
				ON_COMPLETE: function(){
					/* $(Selector.ACTIVITY_CONTAINER).find('.status-notification-div').removeClass('visibility-hidden');
					APP.animationObj.animate({
						EL: $(Selector.ACTIVITY_CONTAINER).find('.status-notification-div'),
						TYPE: 'fade-in-top',
						START_VAL:'10px',
						STAGGER: false,
						DURATION: 0.2,
						DElAY:0,
						ON_COMPLETE: function(){
							
						}
					}); */
					
				}
			});
		},1000)
		
	}

	function addTemplateEvent() {
		$(Selector.ACTIVITY_CONTAINER).find('.module-btn').on('click', function(e){
			var parentBlock = $(this).parents('.mod-btn-block');			
			if(parentBlock.hasClass('locked') || $(this).hasClass('disabled')){return false;};
			e.stopPropagation();
			APP.commonFunObj.playSoundEffect({name: 'clicked'});
			var id = parentBlock.attr('id');
			var modId = parseInt($(this).data('modid'));
			var currentView = APP.commonFunObj.getCurrentView();
			if(currentView == 'mobile'){
				//for mobile
				APP.navData.moduleId = modId;
				APP.navData.topicId = 0;
				APP.navData.screenId = 0;
				APP.navigationObj.loadScreen();
			}else{
				
				APP.navData.moduleId = modId;
				APP.navData.topicId = 0;
				APP.navData.screenId = 0;
				APP.navigationObj.loadScreen();				
			}
		})

		$(Selector.ACTIVITY_CONTAINER).find('.reset-learning-btn').on('click', function(){
			if($(this).hasClass('disabled')){return false;};			
			//APP.navigationObj.loadScreenByType('profiler1Screen');
			APP.commonFunObj.showResetTrainingPop();
		})
		//--for certificate
		$(Selector.ACTIVITY_CONTAINER).find('.certificate-btn').on('click', function(){
			var sts = APP.dataComObj.getLessonStatus();
			if(sts == 'completed' || APP.courseDataObj.isAllMandatoryTopicCompleted()){			
				APP.navigationObj.loadCertificateScreen();
			}else{
				APP.commonFunObj.showCompleteMandatoryPop();					
			}	
				
		});	
	}
	function showModPop(_id, _delay){
		var delay = _delay || 0;
		var el= $(Selector.ACTIVITY_CONTAINER).find('.module-pop_'+_id);
		if(el.hasClass('shown')){return false;}
		$(Selector.ACTIVITY_CONTAINER).find('.module-pop').addClass('hide').removeClass('shown');
		//$(Selector.ACTIVITY_CONTAINER).find('.module-pop_'+currentModuleId).removeClass('hide');
		
		el.removeClass('hide');
		
		APP.animationObj.animate({
			EL: el,
			TYPE: 'fade-in-top',
			START_VAL:'20px',
			END_VAL:'0px',
			DURATION: 0.5,
			DELAY: delay,
			ON_COMPLETE: function(){
				el.addClass('shown');
			}
		});
	}
	function applyTopicBtnEvent(){
		$(Selector.ACTIVITY_CONTAINER).find('.topic-btn').on('click', function(){			
			if(Selector.MODE === 'selectable'){
				if($(this).hasClass('mandatory')){return false;};
				var _idClass = $(this).attr('id');
				if($(this).hasClass('selected')){
					//to apply class for both instance
					$('.'+_idClass).removeClass('selected');
					$('.'+_idClass).find('.check-icon').removeClass('icon-checkbox-checked').addClass('icon-checkbox-unchecked');
				}else{
					$('.'+_idClass).addClass('selected');
					$('.'+_idClass).find('.check-icon').removeClass('icon-checkbox-unchecked').addClass('icon-checkbox-checked');
				}
				checkConfirmBtn();
			}else{
				if($(this).hasClass('locked') || $(this).hasClass('disabled') || $(this).hasClass('current')){return false;};
			
				$(Selector.ACTIVITY_CONTAINER).find('.topic-btn').removeClass('current');
				$(this).addClass('current');
				var isOverPopAvl = $(this).data('over-pop-avl');
				if(isOverPopAvl){
					var obj = {
						modId: $(this).data('modid'),
						topicId: $(this).data('topicid')
					}
					createOverPopup(obj);
				}else{
					//APP.progressBarObj.resetHorizontalProgressBar();
					updateStatus();			
					APP.navData.moduleId = $(this).data('modid');
					APP.navData.topicId = $(this).data('topicid');
					APP.navData.screenId = 0;
					APP.navigationObj.loadScreen();
					//--same function code applied in start btn applyStartBtnEvent()
				}
			}
		})
	}
	
	function createSubTopic(_modId){
		var str = '';
		/* 1 */str += '<div class="module-pop module-pop_'+_modId+'">';			
			var curr = Selector.XML_NODE.menu[0].module[_modId];
			
			var subTopicXmlObj = curr.topic;
			for (var j=0; j<subTopicXmlObj.length; j++){
				var currSubTopic = subTopicXmlObj[j];
				if(currSubTopic.isSkip == 'true'){
					continue;
				}
				var subTopicStatusClass="not-attempted"
				var subTopicStatus = APP.courseDataObj.getTopicStatus(_modId, j);
				if(subTopicStatus == '1'){
					subTopicStatusClass = "incomplete"
				}
				if(subTopicStatus == '2'){
					subTopicStatusClass = "complete"
				}
				var tref = 'topic-'+_modId+'_'+j;

				var ttxt = currSubTopic.title[0].Text;
				var icoClass = currSubTopic.iconClass || '';
				var className = currSubTopic.className || '';
				var durationMin = currSubTopic.durationMin || '';
				var dataType = currSubTopic.dataType || '';

				var dataType = currSubTopic.dataType || '';
				var tImg = currSubTopic.homeBtnImg || '';

				var tvisibleClass = '';
				if(ttxt == null || ttxt == ''){
					tvisibleClass = 'no-title'
				}
								
				str+='<a id="'+tref+'" class="btn topic-btn '+tref+' '+subTopicStatusClass+' '+tvisibleClass+' '+className+' '+dataType+'" data-modid="'+_modId+'" data-topicid="'+j+'" href="javascript:void(0)">';
					str += '<div class="img-block">';
						if(tImg != null && tImg!= ''){
							str += '<img class="img" src='+tImg+'>';
						}
						str += '<div class="indicator indicator-cell ">';
							str += '<div class="icon-bg"><span class="font-icon status-icon"></span></div>';
						str += '</div>';
					str += '</div>';	
					str += '<div class="txt-block">';		
						str+= '<div class ="btn-txt font-medium" >'+ttxt+'</div>';
						str+= '<div class ="extra-txt" >'+APP.getHtmlStructObj.textPanelStruct(currSubTopic.extraText[0])+'</div>';
					str += '</div>';	
				str += '</a>';	
			}
			
		/* 1 */str += '</div>';
		return str;
	}
	function checkConfirmBtn(){
		updateDurationTxt();
	}
	function updateDurationTxt(){		
		var currModObj = Selector.XML_NODE.menu[0].module[currentModuleId];
		if(currModObj){	
			$(Selector.ACTIVITY_CONTAINER).parents('.screen').find('.duration-to-complete').html(currModObj.durationToComplete);
		}else{
			$(Selector.ACTIVITY_CONTAINER).parents('.screen').find('.duration-panel').addClass('hide');
			$(Selector.ACTIVITY_CONTAINER).parents('.screen').find('.instr-txt').addClass('hide');
		}
		
	}
	function applyStartBtnEvent(){
		$(Selector.ACTIVITY_CONTAINER).find('.start-btn').one('click', function(){
			if($(this).hasClass('disabled')){return false;};			
				//APP.progressBarObj.resetHorizontalProgressBar();
				updateStatus();			
				APP.navData.moduleId = $(this).data('modid');
				APP.navData.topicId = $(this).data('topicid');
				APP.navData.screenId = 0;
				APP.navigationObj.loadScreen();
		})
	}
	function createOverPopup(_obj){
		var modId = _obj.modId;
		var topicId = _obj.topicId;
		var menuXmlObj = Selector.XML_NODE.menu[0];
		topicObj = menuXmlObj.module[modId].topic[topicId];
		var str = '';
		str += '<div class="topic-over-pop topic-over-pop_'+modId+'-'+topicId+'">';			
			str +='<div class="main-box">';				
				str +='<p class="txt topic-title">'+topicObj.preTitle[0].Text+' '+topicObj.title[0].Text+'</p>';
				str +='<div class="text-box">';
					str += APP.getHtmlStructObj.textPanelStruct(topicObj.overPopText[0]);
				str +='</div>';
				str +='<div class="btn-panel start-btn-panel border-btn">';
					str +='<a class="btn start-btn " href="javascript:void(0);" data-modid="'+modId+'" data-topicid="'+topicId+'">';
						str +='<span class="btn-txt display-cell v-center center" >'+APP.globalXmlsObj.globalXML.commonText[0].startBtnText[0].Text+'</span>';
						str +='<span class="btn-icon font-icon icon-next display-cell v-center center" ></span>';
					str +='</a>';
				str +='</div>';
			str +='</div>';
		str +='</div>';
		$(Selector.ACTIVITY_CONTAINER).find(Selector.SUB_MENU_CONTAINER).find('.topic-over-panel').html(str);
		applyStartBtnEvent();
		APP.animationObj.animate({
			EL: $(Selector.ACTIVITY_CONTAINER).find(Selector.SUB_MENU_CONTAINER).find('.topic-over-pop .main-box'),
			TYPE: 'zoom-in',
			STAGGER: false,
			START_VAL: '0.5',
			DURATION: 1,
			ON_COMPLETE: function(){
				
			}
		});
		APP.animationObj.animate({
			EL: $(Selector.ACTIVITY_CONTAINER).find(Selector.SUB_MENU_CONTAINER).find('.topic-over-pop .line'),
			TYPE: 'fade-in-left',
			STAGGER: false,
			DURATION: 1,
			ON_COMPLETE: function(){
				
			}
		});
	}
	function updateTemplateLayout() {
		
		//don't call heavy function here as it is run on screen resize	
		//to prevent being call from other screen 
		/* var activityContainer = $('.menu-container');
		var currentPop = $(activityContainer).data('current-pop');
		
		if(currentPop != null && currentPop!=''){						
			var modBtnBLockObj = $(activityContainer).find('.mod-btn-block.mod-'+currentPop);
			if(modBtnBLockObj.length){					
				var currentView = APP.commonFunObj.getCurrentView();
				if(currentView == 'mobile'){
					modBtnBLockObj.addClass('open');
					modBtnBLockObj.find('.module-btn').removeClass('selected');
					$(activityContainer).find('.right-area-panel').hide();
					var collapseObj = modBtnBLockObj.siblings('.collapse-mod-'+currentPop);	
					collapseObj.show();
					modBtnBLockObj.find('.plus-minus').removeClass(Selector.FONT_ICON_CLASS_OBJ.plus).addClass(Selector.FONT_ICON_CLASS_OBJ.minus);	
				}else{
					modBtnBLockObj.removeClass('open');
					modBtnBLockObj.find('.module-btn').addClass('selected');
					$(activityContainer).find('.collapse-mod').hide();
					$(activityContainer).find('.right-area-panel').show();
					$(activityContainer).find('.right-area-panel').find('.module-pop').hide();	
					$(activityContainer).find('.right-area-panel').find('.module-pop_'+currentPop).show();
				}			
			}		
		} */
	}
	
	$(document).on(APP.eventObj.ON_CUSTOM_RESIZE, function (e) {
		updateTemplateLayout();
	});
	function updateModButtonStatus(){	
		var cheatMode = APP.configObj.cheatMode;	
		var menuContainer = $(Selector.ACTIVITY_CONTAINER);
		//--custom for this course
		var isMod1Complete = APP.courseDataObj.isModuleComplete(1);
		var isMod2Complete = APP.courseDataObj.isModuleComplete(2);
		var isMod3Complete = APP.courseDataObj.isModuleComplete(3);
		
		if(APP.configObj.menu.lockMenu == true && !cheatMode){
			menuContainer.find('.mod-btn-block.not-attempted').addClass('locked');
			menuContainer.find('.mod-btn-block').eq(0).removeClass('locked');
			//menuContainer.find('.mod-btn-block.complete').next('.mod-btn-block').removeClass('locked');
			if(isMod1Complete === true){
				menuContainer.find('.mod-2').removeClass('locked');
			}
			if(isMod1Complete === true && APP.courseDataObj.isAnyTopicComplete(2) === true){
				menuContainer.find('.mod-3').removeClass('locked');
			}
		}
		//--indicator changes	
		menuContainer.find('.mod-btn-block.locked').find('.m-indicator .status-icon').addClass(APP.iconObj.locked);	
		menuContainer.find('.mod-btn-block.not-attempted:not(.locked)').find('.m-indicator .status-icon').addClass(APP.iconObj.notAttempted);
		
		menuContainer.find('.mod-btn-block.incomplete').find('.m-indicator .status-icon').addClass(APP.iconObj.incomplete);
		menuContainer.find('.mod-btn-block.complete').find('.m-indicator .status-icon').addClass(APP.iconObj.complete);	
		
	}
	function updateTopicButtonStatus(){
		var cheatMode = APP.configObj.cheatMode;
		var isMod1Complete = APP.courseDataObj.isModuleComplete(1);
		var subMenuContainer = $(Selector.ACTIVITY_CONTAINER).find('.dynamic-panel')
		if(APP.configObj.menu.lockSubMenu == true && !cheatMode){
			subMenuContainer.find('.topic-btn.not-attempted').addClass('locked');			
			/* subMenuContainer.find('.topic-btn').eq(0).removeClass('locked');
			
			subMenuContainer.find('.mod-btn-block.locked').find('.module-pop').find('.topic-btn').eq(0).addClass('locked');	
			subMenuContainer.find('.topic-btn.complete').next('.topic-btn').removeClass('locked'); */
			if(isMod1Complete == true){
				subMenuContainer.find('.topic-btn').removeClass('locked');
			}
		}		
		//--indicator changes
		subMenuContainer.find('.topic-btn.locked').find('.indicator .status-icon').removeClass(APP.iconObj.notAttempted).addClass(APP.iconObj.locked);
		subMenuContainer.find('.topic-btn.not-attempted:not(.locked)').find('.indicator .status-icon').addClass(APP.iconObj.notAttempted);
		subMenuContainer.find('.topic-btn.incomplete').find('.indicator .status-icon').addClass(APP.iconObj.incomplete);
		subMenuContainer.find('.topic-btn.complete').find('.indicator .status-icon').addClass(APP.iconObj.complete);
		
	}
	function updateStatus() {	
		if (Selector.ON_CLICK) {
			
			Selector.ON_CLICK({arr: Selector.userData});
		}
		Selector.isCompleted = true;		
		if (Selector.isCompleted) {
			screenCompleted();
		}
	}

	function screenCompleted() {
		if (Selector.ON_COMPLETE) {
			Selector.ON_COMPLETE();
		}

	}
}